
    'use strict';
    var generators = require('yeoman-generator');
    var mkdirp = require('mkdirp');
    var yosay = require('yosay');
    var chalk = require('chalk');
    const fs = require('fs');
    const path = require('path');
    module.exports = generators.Base.extend({

        constructor: function() {
            generators.Base.apply(this, arguments);

            // 获取 AppName，使用路径尾.
            this.appName = path.basename(process.cwd());
        },

        initializing: function() {
            var message = chalk.bgBlack.bold('\nWelcome to webApp\n') + chalk.underline('webApp.github.io\n');
            this.log("开始构建项目...");
            this.log(yosay(message));
        },

        // prompting: function () {
          // let models = [{
          //     name: 'eslint',
          //     checked: true
          // }, {
          //     name: 'sass-lint',
          //     checked: true
          // }];
  
          // const prompts = [{
          //     type: 'checkbox',
          //     name: 'enable',
          //     message: '开启哪些功能？',
          //     choices: models
          // }, {
          //     type: 'confirm',
          //     name: 'installDependencies',
          //     message: '安装相关依赖？',
          //     when: (props) => {
          //         return props.enable.length;
          //     }
          // }, {
          //     type: 'list',
          //     name: 'tool',
          //     message: '使用npm/tnpm？',
          //     choices: [
          //         CFG.CHOICE.TOOL.NPM,
          //         CFG.CHOICE.TOOL.TNPM
          //     ],
          //     when: (props) => {
          //         return props.installDependencies;
          //     }
          // }];
  
          // return this.prompt(prompts).then((options) => {
          //     this.userOptions = options;
          // });
        // },

        /**
         * 写入配置
         */
        configuring() {

            // 获取 package 配置模板.
            let defaultSettings = this.fs.readJSON( this.templatePath('package.json') );
            // 做新 package 配置文件.
            let packageSettings = {
            name: this.appName,
            private: true,
            version: '0.0.1',
            description: `${this.appName} - Generated by svue`,
            main: 'index.js',
            scripts: defaultSettings.scripts,
            repository: defaultSettings.repository,
            keywords: [],
            author: this.appAuthor,
            devDependencies: defaultSettings.devDependencies,
            dependencies: defaultSettings.dependencies
            };

            // 写入 package.json.
            this.fs.writeJSON(this.destinationPath('package.json'), packageSettings);
        },
        writing: function() {
            // 创建dist空目录
            fs.mkdirSync('dist');
            /**  复制基础样板文件 */
            this.fs.copy(
                this.templatePath('build'),
                this.destinationPath('build')
            );

            this.fs.copy(
                this.templatePath('pic'),
                this.destinationPath('pic')
            );

            this.fs.copy(
                this.templatePath('src'),
                this.destinationPath('src')
            );

            this.fs.copy(
                this.templatePath('env.js'),
                this.destinationPath('env.js')
            );

            this.fs.copyTpl(
                this.templatePath('index.html'),
                this.destinationPath('index.html'),
                { title: 'Templating with Yeoman' }
            );

            this.fs.copy(
                this.templatePath('README.md'),
                this.destinationPath('README.md')
            );

            this.fs.copy(
                this.templatePath('td_icon.ico'),
                this.destinationPath('td_icon.ico')
            );
        },
        /**
         * 安装方法
         */
        // install() {
        //     // 安装 package 安装.
        //     this.installDependencies({ bower: false });
        // }
    });
